/*
 * OscilloscopeControl.h
 *
 *  Created on: 8 Nov 2012
 *      Author: peter.brewster
 */
// a generic scope interface
// this then selects the device driver for some given scope for specifics
#ifndef OSCILLOSCOPECONTROL_H_
#define OSCILLOSCOPECONTROL_H_


//For now, this is the only type, so it all looks a bit OTT


class OscilloscopeControl {
public:

	//enum ScopeTypes {none,Agilent54622D}; hardly worth the bother just yet

	OscilloscopeControl();
	virtual ~OscilloscopeControl();

	bool SelectScope (char ScopeTypeId);   // sort out an enum for this
	bool InitScope (const char* Port);
	bool TestScope (void);

// basic stuff
	bool SetTimeBase (char Channel, double TimeBase);
	bool SetVoltsDiv (char Channel, double VoltsDiv);
	bool SetOffset (char Channel, double Offset);
	bool SetOnOff (char Channel , bool OnOff);

//trigger stuff
	bool SetTriggerOffset (double Offset);
	bool SetTriggerMode (char TrigMode);  // sort out an enum for this
	bool SetTriggerLevel (double TrigLevel);
	bool SetTriggerChannel (char Channel);

//run,stop,single etc
	bool SetScopeRun (void);
	bool SetScopeStop (void);
	bool SetScopeSingle (void);


// get things
	double GetTimeBase (char Channel, bool error);
	double GetVoltsDiv (char Channel, bool error);
	bool GetData(char channel,double *data);

};

#endif /* OSCILLOSCOPECONTROL_H_ */
