/*
 * SincFilter.cpp
 *
 *  Created on: 19 Nov 2012
 *      Author: peter.brewster
*/
using namespace std;
#include <stdlib.h>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include "SincFilter.h"
#include <math.h>
#include "FileOut.h"
#include "FileIn.h"


#define PI 3.14159265
// user sets these parameters


SincFilter::SincFilter()
{
	// TODO Auto-generated constructor stub
}

SincFilter::~SincFilter()

{
	// TODO Auto-generated destructor stub
}

KernelParameters * SincFilter::GetKernelParametersHandle (void)
{
		return (&KernParams);


}

	bool SincFilter::SetKernelLength (unsigned int KernLen)
	{
			//KernelLength=KernLen;  // this is the even number, the kernel will actually have
			KernParams.KernelLength = KernLen;

			//n+1 elements in it
			return (1);

	}

	bool SincFilter::SetInputLength (double InputLen)

	{
		InputLength = InputLen;
		return (1);

	}

	bool SincFilter::SetBand1Notch0 (bool BandNotch)
	{
		KernParams.IsBandNotch=BandNotch;
		//IsBandNotNotch=BandNotch   //make a band pass filter if '1', or
		return (1);
	}

	bool SincFilter::SetCentreFreq (double CentreFreq)
	{
		KernParams.CentreFreq=CentreFreq;
		return (1);

	}

	bool SincFilter::SetDeviation (double Deviation)
	{
		KernParams.Deviation = Deviation;
		return (1);
	}

	bool SincFilter::SetGainAtten (double GainAtten)
	{
		KernParams.GainAtten=GainAtten;
		return (1);
		}

	bool SincFilter::SetSampleFrequency (double SampFreq)
	{
		SampleFrequency = SampFreq;
		return (1);
		}

	bool SincFilter::SetInputSet (double * InputData)
	{
		InputWaveForm = InputData;
		return (1);
		}



	bool SincFilter::SetOutputData (double * FilterResults)
	{
		FilterOutput=FilterResults;
		return (1);
	}



	//////////////////////////////////
	// Make Filter
	// Assembles final filter adding the various others, doing spectral inversions, etr
	// Currently will assume a band
	bool SincFilter::MakeFilter (bool go)
	{

		const char LowPassFile[]="C:/SincFilter/kernels/LowPass.txt";
		const char LowPass2File[]="C:/SincFilter/kernels/LowPass2.txt";
		const char HighPassFile[]="C:/SincFilter/kernels/HighPass.txt";
		const char NotchFile[]="C:/SincFilter/kernels/Notch.txt";
		const char BandPassFile[]="C:/SincFilter/kernels/BandPass.txt";

		bool Ok; //not really doing anything with this just yet
		double frequency;

		// Make LowPass Filter
		frequency = KernParams.CentreFreq - KernParams.Deviation;
		Ok=CalculateKernel(frequency,KernParams.KernelLength,1,LowPassFile);  //currently assume gain =1



		// Make High Pass Filter  -- several stages
		//1. Make the low pass filter that will be transformed to high pass
		frequency = KernParams.CentreFreq + KernParams.Deviation;
		Ok=CalculateKernel(frequency,KernParams.KernelLength,1,LowPass2File);  //currently assume gain =1

		// 2. Make a high pass based on this filter
		SpectralInversion(LowPass2File,HighPassFile);

		// 3. Sum the low and high pass filters to get a Notch Filter
		SumKernels (LowPassFile,HighPassFile,NotchFile);

		//4. Apply spectral inversion to get make band  pass response IF a band pass is required

		SpectralInversion (NotchFile,BandPassFile);

		// *************investigate = should the final filter be normalised for gain?

		return (true);

	}
	//
	///////////////////////////////////




	bool SincFilter::RunFilter (bool go)
	{

		return (true);
		}
///////////////////////////////////////////////////////////////
//Calculate Kernel
// calculates a single windowed sinc filter, (low pass)
	bool SincFilter::CalculateKernel(double Frequency,unsigned int KernLen,double GainAtten,const char *Kernel)
	{
		/*
		'
		' where :
		'
		'      Frequency = centre frequency  This is not absolute, it is decimal fraction of
		'      Kernlen = Kernel Length (Actual Kernel is Kernlen+1
		'      GainAtten= Gain or attenuation.Typically unity
		'
		'	   i = Index to term being calculated
		'
		'      h(i) = K ( (sin(2pi.Fc(i-M/2))) / (i-M/2) )*[0.42 - 0.5cos(2pi.i/M) + 0.08cos(4pi.i)]
		'
		'       K is used to normalise the kernel so that the total of the elements = GainAtten
		'       this is done as a final pass of kernel,
		'
		'       purely for readability, the above is broken down here
		'
		'       Term1 is  (sin(2pi.Fp(i-M/2)))/(i-(M/2))
		'       Term2 is [0.42 - 0.5cos(2pi.i/M) + 0.08cos(4pi.i)]
		'
		'       to avoid divide by zero when i=M/2
		'       just set Term1 to  2piFcK  */

		unsigned int i;
		unsigned int KernLenInt;
		unsigned int KernLenIntDiv2;
		double Term1;
		double Term2;
		double TermPiF;
		double output;
		const char FileName[]="TempFile.txt";

		FileOut TheFile;
		TheFile.OpenFile(FileName);





		double TermIminusKernLenDiv2;

		KernLenInt=KernParams.KernelLength;

		KernLenIntDiv2 = KernLenInt/2;
		TermPiF=2 * PI * Frequency;

		for (i=0;i<=KernLenInt;i++)
		{
			if (i==KernLenIntDiv2)
			{
				Term1 = TermPiF;
			}
			else
			{
				TermIminusKernLenDiv2 = (double)i-(double)KernLenIntDiv2;
				Term1=  (sin(TermPiF * TermIminusKernLenDiv2 ))/(TermIminusKernLenDiv2 );
			}
			Term2 = (double) (0.42 -   (cos( (2 * PI * i) / KernLenInt))  + (cos((4 * PI * i) / KernLenInt) * 0.08));
			output=Term1 * Term2;
			TheFile.WriteDouble(output);
		}

	     TheFile.CloseFile();

		//NormalizeKernel(Kernel,KernParams.GainAtten,KernParams.KernelLength );  force gain to 1 for now
		NormalizeKernel(FileName,Kernel,1,KernParams.KernelLength );
	}
//
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//
//Spectral inverter. Only for Kernels with symmetry
// Pete Brewster Nov 2012

	bool SincFilter::SpectralInversion (const char *InputKernel,const char *OutputKernel)	{
		 unsigned int i;
		 unsigned int KernLenInt;

		 double FilterTerm;

		 FileIn KernIn;
		 FileOut KernOut;

		 KernIn.OpenFile(InputKernel);
		 KernOut.OpenFile(OutputKernel);

		 KernLenInt=KernParams.KernelLength;

		for (i=0;i<=KernLenInt;i++)
		{
			KernIn.GetDouble(&FilterTerm);
			FilterTerm=FilterTerm*-1;
			if (i==(KernLenInt/2))
			{
				FilterTerm+=1;
			}
			KernOut.WriteDouble(FilterTerm);
		}
		KernOut.CloseFile();
		KernIn.ResetFile();
		KernIn.CloseFile();

		return (1);
		}
//
///////////////////////////////////////////////////////////////////////
	bool SincFilter::NormalizeKernel (const char *InputKernel,const char *OutputKernel,double GainAtten,unsigned int KernLenNotUsed)
	{
		double KernelSum;
		double temp;
		unsigned int i;
		double K;
		string FileLine;
		unsigned int KernLen;
		KernLen=KernParams.KernelLength;
		FileIn  KernIn;
		FileOut Kernout;

		KernelSum=0;
		KernIn.OpenFile(InputKernel);

		for (i=0;i<=KernLen;i++)
		{
			KernIn.GetDouble(&temp);
			KernelSum+=temp; //sum the terms
		}
		K= GainAtten/KernelSum;//work out correction factor
//probably a nicer way to do this
		KernIn.ResetFile();
		KernIn.CloseFile();

		KernIn.OpenFile(InputKernel);
		Kernout.OpenFile(OutputKernel);

		double KernelCorrect;
		for (i=0;i<=KernLen;i++)
		{
			KernIn.GetDouble(&temp);
			KernelCorrect=temp*K; //sum the terms
			Kernout.WriteDouble(KernelCorrect);
		}


		KernIn.ResetFile();
		Kernout.CloseFile();
		KernIn.CloseFile();

		return(1);
	}

///////////////////////////////////////////////
// Trivial just adds the Kernels term by term
	bool SincFilter::SumKernels (const char * InKernel1,const char * InKernel2,const char * OutputKernel)
	{
		unsigned int i;
		unsigned int KernLen;

		double input1;
		double input2;
		double output;

		KernLen=KernParams.KernelLength;

		FileIn Kern1;
		FileIn Kern2;
		FileOut KernOut;

		Kern1.OpenFile(InKernel1);
		Kern2.OpenFile(InKernel2);
		KernOut.OpenFile(OutputKernel);

		for (i=0;i<=KernLen;i++)
		{
			Kern1.GetDouble(&input1);
			Kern2.GetDouble(&input2);
			output=input1+input2;
			KernOut.WriteDouble(output);
		}

		Kern1.ResetFile();
		Kern1.CloseFile();


		Kern2.ResetFile();
		Kern2.CloseFile();


		KernOut.CloseFile();


		return (1);
	}
//
////////////////////////////////////////////////////
//////////////////
// Convolve 'kernel' with 'InputWaveForm'
// where InputWaveForm is a static double array, kernel is whatever kernel has been pointed at
// sample length and kernel lengths are static data also for now
	bool SincFilter::DoConvolution (double * Kernel)
	{
		//not doing it here any more, see somewhere else and the CircularMAC class

		return (1);

	}

