/*
 * SincFilter.h
 *
 *  Created on: 19 Nov 2012
 *      Author: peter.brewster
 */

#ifndef SINCFILTER_H_
#define SINCFILTER_H_

struct KernelParameters {
				unsigned int KernelLength;
				double CentreFreq;
				double Deviation;
				double GainAtten;
				bool IsBandNotch;
			};


class SincFilter {
public:
	SincFilter();
	virtual ~SincFilter();

	// should  be a struct for the Kernel parameters!!!!
	// cut down on number of functions!



	KernelParameters * GetKernelParametersHandle (void);

	// probably look to getting rid of the things below!
			// no, keep them for now!
	bool SetKernelLength (unsigned int KernLen);
	bool SetInputLength (double InputLen);
	bool SetBand1Notch0 (bool BandNotch);
	bool SetCentreFreq (double CentreFreq);
	bool SetDeviation (double Deviation);
	bool SetGainAtten (double BandWindth);
	bool SetSampleFrequency (double SampFreq);
	bool SetInputSet (double * InputData);
	bool SetOutputData (double * FilterResults);

	bool MakeFilter (bool go);
	bool RunFilter (bool go);



private:
	bool CalculateKernel(double Frequency,unsigned int KernLen,double GainAtten,const char *Kernel);
	bool SpectralInversion (const char *InputKernel,const char *OutputKernel);
	bool SumKernels (const char * Kernel1,const char * Kernel2,const char * KernelOut);

	bool DoConvolution (double * Kernel);
	bool NormalizeKernel (const char *InputKernel,const char *OutputKernel,double GainAtten,unsigned int KernLen);
	KernelParameters KernParams;
	double InputLength;
	double SampleFrequency;
	double * InputWaveForm;
	double * FilterOutput;
	double OutputLength;






}; /* namespace std */
#endif /* SINCFILTER_H_ */
